open Position
open Global
open Global.TML
open Global.SV
open Node


let rec kill_me id kill local_kill () =
  await kill (fun k ->
    if List.mem id (List.map (fun (SV_Int i) -> i) k)
    then (emit local_kill SV_Null; term ())
    else kill_me id kill local_kill ())

let preemptible_node id pos_init kill () =
  let local_kill = signal() in
  tail_par
    (fun () -> (dountil local_kill (node id pos_init) term))
    (kill_me id kill local_kill)

let rec add new_node start () =
  await_one new_node 
    (fun (SV_Pos pos) ->
      tail_par
	(add new_node start)
	(fun () -> await_immediate start
	    (fun () -> 
	      let pos = { x = if pos.x > 0. then min pos.x max_x else 0.;
			  y = if pos.y > 0. then min pos.y max_y else 0.; } 
	      in
	      node (get_new_id()) pos ())))

