open Position
open Global
open Global.TML
open Global.SV
open Node
open Draw  

let _ =
  init_make_move := (fun pos -> Move.rwp (4. *. coverage_range) pos);
  init_make_make_msg := (fun () -> Msg.make_msg);
  init_make_insert_elip_info := (fun pos -> Msg.insert_proba)

(*  init_make_insert_elip_info := (fun pos -> Msg.insert_proba)
  init_make_insert_elip_info := (fun pos -> Msg.insert_locality pos)
  init_make_insert_elip_info := (fun pos -> Msg.insert_angle ())
  init_make_insert_elip_info := (fun pos -> Msg.insert_proba_locality pos)*)


let make_nodes n () =
  tail_fordopar 1 n
    (fun i -> 
      let pos = { x = Random.float max_x;
		  y = Random.float max_y } 
      in
      node (get_new_id()) pos ())
    

let make_preemptible_nodes n kill () =
  tail_fordopar 1 n
    (fun i ->
      let pos = { x = Random.float max_x;
		  y = Random.float max_y } 
      in
      Dynamic.preemptible_node (get_new_id()) pos kill ())


let main () =
  Area.make_areas;
  let suspend = signal () in
  let start  = signal () in
  let new_node = signal () in
  let kill = signal () in
  tail_parn 
    [
     (fun () -> controlwith suspend
	 (fun () -> tail_parn
	    [
	     (* run (make_nodes nb_nodes) *)
	     make_preemptible_nodes nb_nodes kill;
	     (*make_nodes nb_nodes;*)
	     
	     (Dynamic.add new_node start);
	     
	     let rec loop () = 
	       emit start SV_Null;
	       pause (fun () ->
		 pause (fun () ->
		   pause loop))
	     in loop;
	     
	     if with_stat then Stat.stat start else term
	   ])
	 term)
       ;
     (if with_graphics then
       draw_simul draw suspend new_node kill else term)
       ;

     (fun () -> 
     if nb_instants > 0 then
       let rec loop i k () = 
	 if i = 0 then k() else
	 pause (loop (i-1) k)
       in
       let t_init = Unix.time () in
       loop (nb_instants*3)
	 (fun () ->
	   let t_fin = Unix.time () in
	   let proc_time = Sys.time() in
	   let gc_stat = Gc.stat() in
	   print_int nb_nodes;
	   print_char '\t';
	   print_float max_x;
	   print_char '\t';
	   print_float coverage_range;
	   print_char '\t';
	   print_float area_size_x;
	   print_char '\t';
	   print_float (t_fin -. t_init);
	   print_char '\t';
	   print_float proc_time;
	   print_char '\t';
	   print_int gc_stat.Gc.top_heap_words;
	   print_char '\t';
	   print_float ((t_fin -. t_init) /. float_of_int nb_instants);
	   print_char '\t';
	   print_float (proc_time /. float_of_int nb_instants);
	   print_char '\t';
	   print_newline();
(*      Gc.print_stat stdout;*)
	   exit 0; term()) ()
     else term ())
   ]
;;

start [ main ]
