
module TML = Tml.Gen_TML(struct type t=int end);;
open TML

let last = ref 0
let show = ref true

let rec integers n s_out () =
  emit s_out n;
  pause (integers (n+1) s_out)

let rec filter prime s_in s_out () =
  await_one s_in (fun n ->
    if (n mod prime) != 0 then emit s_out n;
    run (filter prime s_in s_out))

let rec shift s_in s_out () =
  await_one s_in (fun prime ->
    emit s_out prime;
    let s = signal () in
    tail_par (filter prime s_in s)
      (shift s s_out))

let rec output s_in () =
  await_one s_in (fun prime ->
    if prime >= !last then Mem.exit ();
    if !show then begin print_int prime;
      print_string " ";
      flush stdout
    end;
    run (output s_in))

let sieve () =
  let nat = signal () in
  let prime = signal () in
  tail_parn [ integers 2 nat; shift nat prime; output prime ]
;;


Arg.parse [ ("-n", Arg.Set_int last, "set last number to try");
	    ("-q", Arg.Clear show, " quiet: dont display numbers") ]
  (fun _ -> ()) "sieve";

start [ sieve ]

